@ECHO OFF

set num=1
set fail=0
set opt=0

::write static content of the module file
echo.[global]>Unification_New_Races.module
echo.>>Unification_New_Races.module
echo.UIName = Unification New Races>>Unification_New_Races.module
echo.Description = Includes all the features of the standard Vanilla (STEAM) version, AND it seamlessly combines the Race Mods added to it!>>Unification_New_Races.module
echo.DllName = WXPMod>>Unification_New_Races.module
echo.Playable = 1 >>Unification_New_Races.module
echo.ModFolder = Unification_Vanilla_Updates>>Unification_New_Races.module
echo.ModVersion = 3.3>>Unification_New_Races.module
echo.DataFolder.1 = Data>>Unification_New_Races.module
echo.>>Unification_New_Races.module

cls
echo. ----------------------------------------------------
echo. Dawn of War: Unification - New Races Mod Detection
echo. Based on code created by EvilIsador at www.moddb.com
echo. ----------------------------------------------------
echo.
echo.
echo. CHECKING FOR REQUIRED MODS:
echo.

::Add required mods to module file
echo.;; Required mods>>Unification_New_Races.module
echo.RequiredMod.%num% = Unification_Bugfix>>Unification_New_Races.module
set /A num+=1
echo.RequiredMod.%num% = FreeUI>>Unification_New_Races.module
set /A num+=1
echo.RequiredMod.%num% = objective_points_SS>>Unification_New_Races.module
set /A num+=1
echo.>>Unification_New_Races.module

::Check that required mods are installed ok

IF NOT EXIST "Unification_Bugfix.module" GOTO :Unification_Bugfix_error
ECHO. Required mod found - Unification Bugfix.
ECHO.
GOTO :Unification_Bugfix_end
:Unification_Bugfix_error
SET /A fail+=1
ECHO. ++ERROR++ Required mod not found - Unification Bugfix.
ECHO.
:Unification_Bugfix_end

IF NOT EXIST "FreeUI.module" GOTO :FreeUI_error
ECHO. Required mod found - FreeUI.
ECHO.
GOTO :FreeUI_end
:FreeUI_error
SET /A fail+=1
ECHO. ++ERROR++ Required mod not found - FreeUI.
ECHO.
:FreeUI_end

IF NOT EXIST "objective_points_SS.module" GOTO :objective_points_SS_error
ECHO. Required mod found - Objective Points.
ECHO.
GOTO :objective_points_SS_end
:objective_points_SS_error
SET /A fail+=1
ECHO. ++ERROR++ Required mod not found - Objective Points.
ECHO.
:objective_points_SS_end

::Check for optional mods
echo.
echo. CHECKING FOR OPTIONAL MODS:
echo.
echo.;; Optional mods>>Unification_New_Races.module

IF NOT EXIST "AdeptusMechanicus.module" GOTO :AdeptusMechanicus_end
ECHO. Optional mod found - Adeptus Mechanicus Explorators.
ECHO.
echo.RequiredMod.%num% = AdeptusMechanicus>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:AdeptusMechanicus_end

IF NOT EXIST "Blood_Angels_SS.module" GOTO :Blood_Angels_SS_end
ECHO. Optional mod found - Blood Angels.
ECHO.
echo.RequiredMod.%num% = Blood_Angels_SS>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Blood_Angels_SS_end

IF NOT EXIST "Chaos_Daemons.module" GOTO :Chaos_Daemons_end
ECHO. Optional mod found - Chaos Daemons.
ECHO.
echo.RequiredMod.%num% = Chaos_Daemons>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Chaos_Daemons_end

IF NOT EXIST "Craftworld.module" GOTO :Craftworld_end
ECHO. Optional mod found - Craftworld Eldar.
ECHO.
echo.RequiredMod.%num% = Craftworld>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Craftworld_end

IF NOT EXIST "Dark_Angels.module" GOTO :Dark_Angels_end
ECHO. Optional mod found - Dark Angels.
ECHO.
echo.RequiredMod.%num% = Dark_Angels>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Dark_Angels_end

IF NOT EXIST "Death_Guard_Mod.module" GOTO :Death_Guard_Mod_end
ECHO. Optional mod found - Death Guard.
ECHO.
echo.RequiredMod.%num% = Death_Guard_Mod>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Death_Guard_Mod_end

IF NOT EXIST "Emperors_Children.module" GOTO :Emperors_Children_end
ECHO. Optional mod found - Emperor's Children.
ECHO.
echo.RequiredMod.%num% = Emperors_Children>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Emperors_Children_end

IF NOT EXIST "his_righteous_mod.module" GOTO :his_righteous_mod_end
ECHO. Optional mod found - Imperial Guard: His Righteous Mod.
ECHO.
echo.RequiredMod.%num% = his_righteous_mod>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:his_righteous_mod_end

IF NOT EXIST "inquisition_daemonhunt.module" GOTO :inquisition_daemonhunt_end
ECHO. Optional mod found - Inquisition: Daemonhunt.
ECHO.
echo.RequiredMod.%num% = inquisition_daemonhunt>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
GOTO :inquisition_daemonhunt_SS_end
:inquisition_daemonhunt_end

IF NOT EXIST "inquisition_daemonhunt_SS.module" GOTO :inquisition_daemonhunt_SS_end
ECHO. Optional mod found - Inquisition: Daemonhunt.
ECHO.
echo.RequiredMod.%num% = inquisition_daemonhunt_SS>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:inquisition_daemonhunt_SS_end

IF NOT EXIST "iron_warriors_mod.module" GOTO :iron_warriors_mod_end
ECHO. Optional mod found - Iron Warriors.
ECHO.
echo.RequiredMod.%num% = iron_warriors_mod>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:iron_warriors_mod_end

IF NOT EXIST "LOTD.module" GOTO :LOTD_end
ECHO. Optional mod found - Legion of the Damned.
ECHO.
echo.RequiredMod.%num% = LOTD>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:LOTD_end

IF NOT EXIST "Night_Lords.module" GOTO :Night_Lords_end
ECHO. Optional mod found - Night Lords.
ECHO.
echo.RequiredMod.%num% = Night_Lords>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Night_Lords_end

IF NOT EXIST "Praetorian_mod.module" GOTO :Praetorian_mod_end
ECHO. Optional mod found - Praetorian Guard.
ECHO.
echo.RequiredMod.%num% = Praetorian_mod>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Praetorian_mod_end

IF NOT EXIST "RAGE.module" GOTO :RAGE_end
ECHO. Optional mod found - RAGE: World Eaters Warband.
ECHO.
echo.RequiredMod.%num% = RAGE>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:RAGE_end

IF NOT EXIST "Renegade_Guard.module" GOTO :Renegade_Guard_end
ECHO. Optional mod found - Renegade Guard.
ECHO.
echo.RequiredMod.%num% = Renegade_Guard>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
GOTO :Renegade_Guard_64_end
:Renegade_Guard_end

IF NOT EXIST "Renegade_Guard_0.64.module" GOTO :Renegade_Guard_64_end
ECHO. Optional mod found - Renegade Guard.
ECHO.
echo.RequiredMod.%num% = Renegade_Guard_0.64>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Renegade_Guard_64_end

IF NOT EXIST "Salamanders.module" GOTO :Salamanders_end
ECHO. Optional mod found - Salamanders.
ECHO.
echo.RequiredMod.%num% = Salamanders>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Salamanders_end

IF NOT EXIST "Space_Wolves.module" GOTO :Space_Wolves_end
ECHO. Optional mod found - Space Wolves.
ECHO.
echo.RequiredMod.%num% = Space_Wolves>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
GOTO :Space_Wolves_63_end
:Space_Wolves_end

IF NOT EXIST "Space_Wolves_0.63.module" GOTO :Space_Wolves_63_end
ECHO. Optional mod found - Space Wolves.
ECHO.
echo.RequiredMod.%num% = Space_Wolves_0.63>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Space_Wolves_63_end

IF NOT EXIST "Steel_Legions_SS.module" GOTO :Steel_Legions_SS_end
ECHO. Optional mod found - Steel Legion.
ECHO.
echo.RequiredMod.%num% = Steel_Legions_SS>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Steel_Legions_SS_end

IF NOT EXIST "tauva_mod.module" GOTO :tauva_mod_end
ECHO. Optional mod found - Tau Enclaves.
ECHO.
echo.RequiredMod.%num% = tauva_mod>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:tauva_mod_end

IF NOT EXIST "thedancemacabre.module" GOTO :thedancemacabre_end
ECHO. Optional mod found - Harlequins: The Dance Macabre.
ECHO.
echo.RequiredMod.%num% = thedancemacabre>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:thedancemacabre_end

IF NOT EXIST "thirteenth_company_mod.module" GOTO :thirteenth_company_mod_end
ECHO. Optional mod found - 13th Company: Space Wolves.
ECHO.
echo.RequiredMod.%num% = thirteenth_company_mod>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:thirteenth_company_mod_end

IF NOT EXIST "Thousand_Sons.module" GOTO :Thousand_Sons_end
ECHO. Optional mod found - Thousand Sons.
ECHO.
echo.RequiredMod.%num% = Thousand_Sons>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Thousand_Sons_end

IF NOT EXIST "Tyranids.module" GOTO :Tyranids_end
IF NOT EXIST "Tyranids_Art.module" GOTO :Tyranids_end
ECHO. Optional mod found - Tyranids.
ECHO.
echo.RequiredMod.%num% = Tyranids>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
echo.RequiredMod.%num% = Tyranids_Art>>Unification_New_Races.module
set /A num+=1
:Tyranids_end

IF NOT EXIST "Tyranid_Swarm.module" GOTO :Tyranid_Swarm_end
ECHO. Optional mod found - Tyranid Swarm.
ECHO.
echo.RequiredMod.%num% = Tyranid_Swarm>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Tyranid_Swarm_end

IF NOT EXIST "Vostroyan_firstborn.module" GOTO :Vostroyan_firstborn_end
ECHO. Optional mod found - Vostroyan Firstborn.
ECHO.
echo.RequiredMod.%num% = Vostroyan_firstborn>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Vostroyan_firstborn_end

IF NOT EXIST "Witch_Hunters.module" GOTO :Witch_Hunters_end
ECHO. Optional mod found - Witch Hunters: Adepta Sororitas.
ECHO.
echo.RequiredMod.%num% = Witch_Hunters>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:Witch_Hunters_end

::Black Templars moved to the end of the list due to potential conflicts with other race mods
IF NOT EXIST "BTmod.module" GOTO :BTmod_end
ECHO. Optional mod found - Black Templars.
ECHO.
echo.RequiredMod.%num% = BTmod>>Unification_New_Races.module
set /A num+=1
SET /A opt+=1
:BTmod_end

IF NOT '%opt%'=='0' GOTO :optional_end
ECHO. No optional mods found.
ECHO.
:optional_end

::add core game files to module file
echo.>>Unification_New_Races.module
echo.;; Core game files>>Unification_New_Races.module
echo.RequiredMod.%num% = DXP2>>Unification_New_Races.module
set /A num+=1
echo.RequiredMod.%num% = W40k>>Unification_New_Races.module
set /A num+=1

::final check

echo.
echo. SUMMARY:
echo.

IF NOT '%fail%'=='0' GOTO :finish_error
ECHO. All required mods found.
ECHO. Dawn of War: Unification - New Races can now be activated.
GOTO :finish_error_end

:finish_error
IF '%fail%'=='1' GOTO finish_error_1
ECHO. ++ERROR++ %fail% required mods were not found (see above).
ECHO. All required mods must be installed correctly before running Unification - New Races.
GOTO :finish_error_end

:finish_error_1
ECHO. ++ERROR++ 1 required mod was not found (see above).
ECHO. All required mods must be installed correctly before running Unification - New Races.

:finish_error_end
ECHO.

IF '%opt%'=='1' GOTO :finish_optional_1
ECHO. %opt% optional mods found.
ECHO.
GOTO :end

:finish_optional_1
ECHO. 1 optional mod found.
ECHO.

:end

ECHO. Press any key to continue...
PAUSE >nul